#ifndef _APP_H_
#define _APP_H_
#include <iostream.h>
#include <string.h>
#include <conio.h>
#include <graphics.h>
#include "error.h"
#include "mouse.h"
#include "objects.h"

class TApplication {
  private:
    int tag;
    char *title;
    TObject *beg_obj, *end_obj;
    int InitVideo(int mode);
    void DoneVideo();
  public:
    TApplication(char *title, int mode);
    ~TApplication();
    void Run();
    virtual void HandleEvent(TEvent &Event);
    virtual void DefaultProc();
    void InsertControl(TObject *Control);
};

TApplication::TApplication(char *title, int mode)
{
  InitVideo(mode);
  TApplication::title = new char[strlen(title) + 1];
  strcpy(TApplication::title, title);
  beg_obj = NULL;
  end_obj = NULL;
  tag = 0;
}

TApplication::~TApplication()
{
  TObject *P = beg_obj;

  delete title;

  while (P)
  {
    beg_obj = P -> next;
    delete P;
    P = beg_obj;
  }

  DoneVideo();
  cout << "Copyright (c) 1998, 1999 by MATI Inc.\n";
}

void TApplication::DefaultProc()
{
}

void TApplication::Run()
{
  TEvent Event;
  TObject *P;
  beg_obj -> flags |= 2;

  do
  {
    mouse_read(Event.mouse_x, Event.mouse_y, Event.buttons);
    if (kbhit())
      Event.key = getch();
    else
      Event.key = 0;
    P = beg_obj;
    int i = 0;
    while (P != NULL)
    {
      P -> HandleEvent(Event, tag, i++);
      P = P -> next;
    }
    if (tag > --i) tag = 0;
    if (tag < 0) tag = i;
    HandleEvent(Event);
    DefaultProc();
  } while (Event.command != 1);
}

int TApplication::InitVideo(int mode)
{
  int graph_res, graph_driver = DETECT, graph_mode = mode;

  registerbgidriver(EGAVGA_driver);
  registerbgifont(small_font);
  initgraph(&graph_driver, &graph_mode, "..");

  graph_res = (int)graphresult;
  if (graph_res != grOk && graph_res != 781)
  {
    error_exit("Error initializing graphics\n");
  }

  return 0;
}

void TApplication::DoneVideo()
{
  closegraph();
  restorecrtmode();
}

void TApplication::HandleEvent(TEvent &Event)
{
  if (Event.command != 1) Event.command = 0;
  if (Event.key == 9 || /*Event.key == 77 || */Event.key == 80) tag++;
  if (/*Event.key == 75 || */Event.key == 72) tag--;
  Event.key = 0;
}

void TApplication::InsertControl(TObject *Control)
{
  if (beg_obj == NULL)
    beg_obj = Control;
  else
    end_obj -> next = Control;
  end_obj = Control;
}

#endif
