#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <alloc.h>
#include "app.h"
#include "mouse.h"
#include "objects.h"
#include "error.h"
#include "graphic.h"
#include "sb.h"

#define TEST_FREQ  11025

class TFunction {
  public:
    int status;
    int empty;
    int data[640];
    int on;
    float x_scale;
    float y_scale;
    char function[80];
    TFunction();
    void Rebuild();
    void Draw(int color);
    int  Get(float arg);
};

TFunction::TFunction()
{
  empty = 1;
  for (int i = 0; i < 640; i++) data[i] = 0;
  y_scale = 1;
  x_scale = 1;
  on = 1;
  strcpy(function, "");
}

int TFunction::Get(float arg)
{
  Function f(function);

  f.get(0);
  status = f.status;
  if (!f.status && !empty)
    return (int)f.get(arg * x_scale) * y_scale;

  return 0;
}

void TFunction::Rebuild()
{
  Function f(function);

  f.get(0);
  status = f.status;

  if (!f.status)
  for (int i = 0; i < 640; i++)
  {
    empty = f.empty;
    data[i] = (int)f.get(i * x_scale) * y_scale;
    if (data[i] > (getmaxy() - 210) / 2)
      data[i] = (getmaxy() - 210) / 2;
    if (data[i] < (getmaxy() - 210) / -2)
      data[i] = (getmaxy() - 210) / -2;
  }
}

void TFunction::Draw(int color)
{
  setcolor(color);
  moveto(0, (getmaxy() - 205) / 2);
  for (int i = 0; i < 640; i++)
    lineto(i, (getmaxy() - 205) / 2 - data[i]);
}

class TMainApp: public TApplication {
    TFunction *f[8];
    TEdit *P[8];
    TScrollBar *S_X[8];
    TScrollBar *S_Y[8];
    TCheckBox *C[8];
    int data[640];
    unsigned char mic_data[640];
    unsigned char *sb_buf;
    int mic_flag;
  public:
    TMainApp(char *title, int mode);
    ~TMainApp();
    void Init();
    void InitMouse();
    void Redraw();
    void Add();
    void MicToggle();
    void Play();
    virtual void HandleEvent(TEvent &Event);
    virtual void DefaultProc();
};

TMainApp::TMainApp(char *title, int mode): TApplication(title, mode)
{
  for (int i = 0; i < 8; i++)
    f[i] = new TFunction();
  for (int i = 0; i < 640; i++)
    mic_data[i] = 0;
  mic_flag = 0;
  INIT_SB();
}

TMainApp::~TMainApp()
{
  for (int i = 0; i < 8; i++)
    delete f[i];
}

void TMainApp::InitMouse()
{
  mouse_set_pos(getmaxx() / 2, getmaxy() / 2);
  mouse_show();
}

void TMainApp::Init()
{
  TButton *B;
  char buf[5];

  Draw3DBox(0, getmaxy() - 205, getmaxx() + 1, 205);
  setcolor(0);
  settextstyle(SMALL_FONT, HORIZ_DIR, 4);

  for (int i = 0; i < 8; i++)
  {
    P[i] = new TEdit(20, i * 20 + getmaxy() - 175, 200, 15, 100 + i, 30, "");
    InsertControl(P[i]);
    S_X[i] = new TScrollBar(250, i * 20 + getmaxy() - 175, 100, 15, 10, 1000 + i, 0, 20);
    InsertControl(S_X[i]);
    S_Y[i] = new TScrollBar(380, i * 20 + getmaxy() - 175, 100, 15, 10, 1100 + i, 0, 20);
    InsertControl(S_Y[i]);
    sprintf(buf, "%d", i + 1);
    C[i] = new TCheckBox(510, i * 20 + getmaxy() - 175, 15, 1200 + i, buf, 1);
    InsertControl(C[i]);
    Draw3DFrame(10, getmaxy() - 190, 220, 180, "Functions f(x) 0<=x<=640");
    Draw3DFrame(240, getmaxy() - 190, 120, 180, "X Scale");
    Draw3DFrame(370, getmaxy() - 190, 120, 180, "Y Scale");
    Draw3DFrame(500, getmaxy() - 190, 50, 180, "On");
  }
  B = new TButton(560, getmaxy() - 190, 70, 20, 2000, "Redraw", 1);
  InsertControl(B);
  B = new TButton(560, getmaxy() - 160, 70, 20, 3000, "Add", 1);
  InsertControl(B);
  B = new TButton(560, getmaxy() - 130, 70, 20, 4000, "Play", 1);
  InsertControl(B);
  B = new TButton(560, getmaxy() - 100, 70, 20, 5000, "Toggle Mic", 1);
  InsertControl(B);
  B = new TButton(560, getmaxy() - 30, 70, 20, 1, "Exit", 1);
  InsertControl(B);
//  setcolor(0x0B);
//  line(0, (getmaxy() - 205) / 2, getmaxx(), (getmaxy() - 205) / 2);
  Redraw();
  InitMouse();
}

void TMainApp::HandleEvent(TEvent &Event)
{
  switch (Event.command)
  {
    case 2000: if (!mic_flag) Redraw(); break;
    case 3000: if (!mic_flag) Add(); break;
    case 4000: if (!mic_flag) Play(); break;
    case 5000: mic_flag = !mic_flag;
               if (mic_flag)
               {
                 RESET_DSP(BASE);
                 setfillstyle(1, 0);
                 bar(0, 0, getmaxx(), getmaxy() - 206);
               }
  }

  if (Event.command >= 100 && Event.command < 108)
  {
    strcpy(f[Event.command - 100] -> function, P[Event.command - 100] -> text);
    f[Event.command - 100] -> Rebuild();
    if (!mic_flag) Redraw();
  }
  if (Event.command >= 1000 && Event.command < 1008)
  {
    f[Event.command - 1000] -> x_scale = S_X[Event.command - 1000] -> getvalue() / 10;
    f[Event.command - 1000] -> Rebuild();
    if (!mic_flag) Redraw();
  }
  if (Event.command >= 1100 && Event.command < 1108)
  {
    f[Event.command - 1100] -> y_scale = S_Y[Event.command - 1100] -> getvalue() / 10;
    f[Event.command - 1100] -> Rebuild();
    if (!mic_flag) Redraw();
  }
  if (Event.command >= 1200 && Event.command < 1208)
  {
    f[Event.command - 1200] -> on = (C[Event.command - 1200] -> flags & 1);
    f[Event.command - 1200] -> Rebuild();
    if (!mic_flag) Redraw();
  }
  TApplication::HandleEvent(Event);
}

void TMainApp::Redraw()
{
  mouse_hide();

  setfillstyle(1, 0);
  bar(0, 0, getmaxx(), getmaxy() - 206);

  setcolor(8);
  for (int i = 1; i < 32; i++)
    line(i * 20, 0, i * 20, getmaxy() - 206);
  for (int j = 0; j < 14; j++)
    line(0, j * 20 - 3, getmaxx(), j * 20 - 3);

  setcolor(0x0B);
  line(0, (getmaxy() - 205) / 2, getmaxx(), (getmaxy() - 205) / 2);

  for (int i = 0; i < 8; i++)
    if (f[i] -> on && !f[i] -> empty) f[i] -> Draw(i + 1);

  mouse_show();
}

void TMainApp::Add()
{
  setfillstyle(1, 0);
  bar(0, 0, getmaxx(), getmaxy() - 206);
  setcolor(8);
  for (int i = 1; i < 32; i++)
    line(i * 20, 0, i * 20, getmaxy() - 206);
  for (int j = 0; j < 14; j++)
    line(0, j * 20 - 3, getmaxx(), j * 20 - 3);

  setcolor(0x0B);
  line(0, (getmaxy() - 205) / 2, getmaxx(), (getmaxy() - 205) / 2);

  for (int i = 0; i < 640; i++)
    data[i] = 0;

  for (int j = 0; j < 8; j++)
    for (int i = 0; i < 640; i++)
      if ((f[j] -> on) && (f[j] -> status != ERROR))
        data[i] += f[j] -> data[i];

  for (int i = 0; i < 640; i++)
  {
    if (data[i] > (getmaxy() - 210) / 2)
      data[i] = (getmaxy() - 210) / 2;
    if (data[i] < (getmaxy() - 210) / -2)
      data[i] = (getmaxy() - 210) / -2;
  }

  setcolor(15);
  moveto(0, (getmaxy() - 205) / 2);
  for (int i = 0; i < 640; i++)
    lineto(i, (getmaxy() - 205) / 2 - data[i]);
}

void TMainApp::Play()
{
  sb_buf = new unsigned char[TEST_FREQ];
  if (BASE && (sb_buf != NULL))
  {
    Add();
    for (unsigned int i = 0; i < TEST_FREQ; i++)
      sb_buf[i] = 128;
    for (int j = 0; j < 8; j++)
      for (unsigned int i = 0; i < TEST_FREQ; i++)
        if ((f[j] -> on) && (f[j] -> status != ERROR))
          sb_buf[i] += f[j] -> Get(i) * 0.8;
    SPKR_ON();
    PLAY((void far *)sb_buf, TEST_FREQ, TEST_FREQ);
  }
  delete sb_buf;
}

void TMainApp::DefaultProc()
{
  TEvent T;

  if (mic_flag && BASE)
  {
    mouse_read(T.mouse_x, T.mouse_y, T.buttons);
    if (T.mouse_y < getmaxy() - 205) mouse_hide();
    setcolor(0x0B);
    line(0, (getmaxy() - 205) / 2, getmaxx(), (getmaxy() - 205) / 2);
    for (int i = 0; i < getmaxx(); i++)
    {
      putpixel(i, (getmaxy() - 205) / 2 + mic_data[i] - 128, 0);
      mic_data[i] = READ_DAC();
      for (int j = 0; j < 1000; j++);
      putpixel(i, (getmaxy() - 205) / 2 + mic_data[i] - 128, 15);
    }
    mouse_show();
  }
}

int main()
{
  TMainApp *App = new TMainApp("", 3);
  App -> Init();
  App -> Run();
  delete App;
}
